/* Generated by Edge Impulse
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
// Generated on: 31.05.2022 21:47:36

#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include "edge-impulse-sdk/tensorflow/lite/c/builtin_op_data.h"
#include "edge-impulse-sdk/tensorflow/lite/c/common.h"
#include "edge-impulse-sdk/tensorflow/lite/micro/micro_mutable_op_resolver.h"
#include "edge-impulse-sdk/porting/ei_classifier_porting.h"

#if EI_CLASSIFIER_PRINT_STATE
#if defined(__cplusplus) && EI_C_LINKAGE == 1
extern "C" {
    extern void ei_printf(const char *format, ...);
}
#else
extern void ei_printf(const char *format, ...);
#endif
#endif

#if defined __GNUC__
#define ALIGN(X) __attribute__((aligned(X)))
#elif defined _MSC_VER
#define ALIGN(X) __declspec(align(X))
#elif defined __TASKING__
#define ALIGN(X) __align(X)
#endif

using namespace tflite;
using namespace tflite::ops;
using namespace tflite::ops::micro;

namespace {

constexpr int kTensorArenaSize = 288;

#if defined(EI_CLASSIFIER_ALLOCATION_STATIC)
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16);
#elif defined(EI_CLASSIFIER_ALLOCATION_STATIC_HIMAX)
#pragma Bss(".tensor_arena")
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16);
#pragma Bss()
#elif defined(EI_CLASSIFIER_ALLOCATION_STATIC_HIMAX_GNU)
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16) __attribute__((section(".tensor_arena")));
#else
#define EI_CLASSIFIER_ALLOCATION_HEAP 1
uint8_t* tensor_arena = NULL;
#endif

static uint8_t* tensor_boundary;
static uint8_t* current_location;

template <int SZ, class T> struct TfArray {
  int sz; T elem[SZ];
};
enum used_operators_e {
  OP_FULLY_CONNECTED, OP_SOFTMAX,  OP_LAST
};
struct TensorInfo_t { // subset of TfLiteTensor used for initialization from constant memory
  TfLiteAllocationType allocation_type;
  TfLiteType type;
  void* data;
  TfLiteIntArray* dims;
  size_t bytes;
  TfLiteQuantization quantization;
};
struct NodeInfo_t { // subset of TfLiteNode used for initialization from constant memory
  struct TfLiteIntArray* inputs;
  struct TfLiteIntArray* outputs;
  void* builtin_data;
  used_operators_e used_op_index;
};

TfLiteContext ctx{};
TfLiteTensor tflTensors[11];
TfLiteEvalTensor tflEvalTensors[11];
TfLiteRegistration registrations[OP_LAST];
TfLiteNode tflNodes[4];

const TfArray<2, int> tensor_dimension0 = { 2, { 1,12 } };
const TfArray<1, float> quant0_scale = { 1, { 0.062662743031978607, } };
const TfArray<1, int> quant0_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant0 = { (TfLiteFloatArray*)&quant0_scale, (TfLiteIntArray*)&quant0_zero, 0 };
const ALIGN(16) int8_t tensor_data1[64*12] = { 
  -110, 70, -35, 72, -68, 75, 10, -11, -8, 94, 25, -24, 
  17, -12, -2, 73, 28, -24, 84, 3, 78, 60, -75, 64, 
  15, -28, 54, -3, 100, -37, -5, 66, 18, -27, -119, -83, 
  -84, -20, 22, 70, -6, -23, -24, -3, -25, -77, 6, 27, 
  1, -99, 26, 34, 95, -37, 10, 78, 38, -43, -56, 15, 
  50, 40, 42, 3, -80, -53, -74, 32, -13, 33, 33, 102, 
  -65, -65, 44, -22, -19, -18, -9, -50, -73, -52, -54, 32, 
  -4, -35, -46, 83, 50, -1, 64, 14, 74, -2, -94, -84, 
  27, -49, -9, 78, -18, 15, -18, -39, -79, -1, -38, -48, 
  9, 80, 20, 58, -31, 41, 96, 79, 54, 34, 2, 48, 
  -69, -41, -2, -29, -61, -54, -50, -26, 9, -24, -80, -83, 
  71, 30, 14, 17, -12, 27, 75, 83, 14, 58, -59, -31, 
  21, -3, -55, 38, -2, 58, 6, -67, 72, -33, -60, -10, 
  17, -80, 73, -44, -6, -55, 60, -56, 6, 51, 27, -78, 
  -76, 109, -4, -56, 81, -22, 2, 42, -25, -51, 83, 77, 
  -55, 39, 11, 52, -60, -9, -14, -9, 58, 53, -76, 11, 
  -11, -22, -25, -73, 94, 73, 90, 28, -64, -39, -11, -46, 
  -38, 18, 29, 3, -36, 4, -6, -28, -30, -38, 16, -28, 
  -13, -21, -10, 18, 1, -28, 62, -71, -67, 23, 88, 39, 
  -63, 82, -60, 6, -14, 52, -55, 27, 21, 29, 109, 43, 
  -86, 25, 26, 23, -45, -8, 11, -67, -95, 89, 85, 57, 
  16, -13, -56, 69, -23, -77, -41, 74, 55, 59, -1, 7, 
  -85, -33, -3, -73, -9, -20, 16, -78, -64, -5, 34, 20, 
  0, -67, 88, -20, 17, 3, -1, 32, 67, -123, -109, -127, 
  51, 71, -28, 10, 39, -25, -5, -8, -17, -33, 70, 8, 
  -37, -68, -11, 17, -39, 42, 64, -22, -50, 87, 96, 10, 
  77, 67, 56, -72, 52, 34, -52, 18, 54, -85, -36, -62, 
  91, 18, -36, -14, 13, -62, 50, -63, 5, 27, -18, 96, 
  44, 53, -61, -50, -73, -26, -82, 72, 52, 13, 42, -37, 
  13, 4, 54, -48, 56, 69, -91, -77, 35, 37, -67, 74, 
  -94, 40, -57, -22, 74, 50, 14, 78, -52, 31, -9, 12, 
  49, -21, -71, -71, -44, 54, 24, -73, -25, -89, -45, -35, 
  60, -1, -68, 5, -86, -4, -37, -45, 40, -18, 85, 6, 
  35, 69, -67, -59, -12, -62, -89, 23, -36, -39, 70, 107, 
  -113, 83, -37, -50, -4, -24, 66, -21, 30, 99, 73, 53, 
  82, 37, 22, -41, -56, 62, -25, -6, 31, -59, 68, 84, 
  77, 11, 21, 85, 74, 43, -81, -11, 16, 61, 58, 62, 
  5, 81, -2, -28, 4, -14, -47, -59, -54, -85, 20, 48, 
  -27, 37, -44, 68, -1, -12, -8, 31, 56, 3, -2, -23, 
  41, 19, 70, 73, 84, -80, -60, -18, 63, -51, 74, 14, 
  -58, 69, 27, -51, -64, 50, -43, -44, 19, -2, 18, 36, 
  3, 20, 69, 103, 28, 79, -60, 66, 15, 20, -110, -8, 
  -71, 22, 9, -18, -41, 69, -14, -41, -15, 47, -60, 58, 
  -38, 79, 64, 40, 73, 83, -64, 66, 38, -81, -19, 21, 
  -52, 40, -12, -70, 85, 20, -24, -72, 10, -77, -44, 10, 
  3, -17, 46, 57, -2, 70, -43, -88, 86, 70, -35, 53, 
  -57, 6, 21, -48, -78, 31, 11, 67, -7, 76, -19, 22, 
  -29, 67, 13, 86, -19, 3, -43, -54, 68, 81, 26, 61, 
  31, 2, -3, -52, -7, 74, -9, 73, -18, -15, 91, 22, 
  9, -7, -58, -28, -2, 65, -36, 80, -42, 85, -10, -49, 
  -114, -31, -32, -72, 20, -21, 39, -54, -18, -19, 82, 13, 
  -2, 109, 85, 22, -19, 74, -30, 81, 88, 106, 96, 87, 
  15, -1, 13, -6, -53, -83, -78, -50, 79, 32, -74, -28, 
  -5, -10, 67, 85, -41, 33, -19, -32, 61, 47, 81, 35, 
  84, 29, 3, -89, -74, -55, -85, 65, 23, -16, 68, -11, 
  -29, -2, 67, -74, 23, 42, 35, 70, 23, 34, 55, -42, 
  50, -90, 9, -4, -79, -79, 85, -42, 71, -33, 17, 20, 
  -82, 55, -72, -41, 18, -46, -69, 40, 75, 87, -77, 60, 
  70, -82, 44, 13, -19, -76, -47, 0, 27, 0, 39, -41, 
  63, -68, -76, 1, -80, 10, 74, -80, -57, -60, 39, -53, 
  4, -78, -98, -76, 45, -48, -16, 84, 76, -43, -64, -91, 
  -41, 23, -18, 43, -24, 43, -12, -57, 82, 18, 78, 89, 
  46, 39, 79, -52, 81, -61, 95, 42, -26, 56, 51, 31, 
  38, 9, 89, -27, 35, 56, -81, -60, 6, -51, 75, 49, 
};
const TfArray<2, int> tensor_dimension1 = { 2, { 64,12 } };
const TfArray<1, float> quant1_scale = { 1, { 0.003213430754840374, } };
const TfArray<1, int> quant1_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant1 = { (TfLiteFloatArray*)&quant1_scale, (TfLiteIntArray*)&quant1_zero, 0 };
const ALIGN(16) int32_t tensor_data2[64] = { -1263, 682, 1430, 0, 1433, -132, 0, 1025, 0, 756, 0, 855, 1436, -286, -988, -30, 1283, 0, 1334, -1236, -530, 1108, 0, 1457, -799, 434, 611, 104, 1381, -108, -379, 58, 360, -328, -900, -995, -541, 0, -1021, -44, -122, 1460, -50, 515, 0, 1476, -1424, 1018, -1094, -1049, -522, -1407, 0, -1105, 380, -849, 1090, 0, -101, -179, 1379, 232, -154, 232, };
const TfArray<1, int> tensor_dimension2 = { 1, { 64 } };
const TfArray<1, float> quant2_scale = { 1, { 0.00020136238890700042, } };
const TfArray<1, int> quant2_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant2 = { (TfLiteFloatArray*)&quant2_scale, (TfLiteIntArray*)&quant2_zero, 0 };
const ALIGN(16) int8_t tensor_data3[32*64] = { 
  -46, -20, 10, 47, 59, -53, -16, 32, 33, 41, 19, 41, 62, -46, -11, -34, 6, 50, -48, -38, -49, -46, 44, 55, 1, -53, 24, 4, 18, -26, -3, -48, -59, -65, -38, 5, -48, 41, -31, -39, 21, 26, 17, -44, 24, 49, -58, -41, 26, -34, 30, 22, -31, -58, -47, 30, -12, -25, 49, 4, 34, -8, 10, 2, 
  -49, -40, -9, 36, -37, -61, -37, -10, 32, 17, 35, -37, 70, -16, 28, 9, -28, 57, 24, -39, -52, 111, -11, -5, 52, 38, -52, -68, 10, -18, 5, -45, -11, -47, 34, 48, -5, 24, 4, 65, 45, -35, 29, 45, 14, 59, -77, -5, -49, -18, 4, 6, 18, 4, 46, 31, 30, -14, -69, -9, 43, 54, 19, -20, 
  -55, -24, 66, -40, 71, -23, 13, 2, -15, -18, 9, 29, 62, 32, 39, 0, 69, -33, 67, -33, -13, 52, 1, 25, -5, 73, 28, 28, 28, -8, 41, 14, 9, 1, -26, 13, -29, -36, 30, -54, 31, 32, -32, -3, 23, 114, 17, 96, -29, -28, -18, -37, 50, -88, 2, -43, 43, -56, -15, -7, 90, 43, 7, 3, 
  -11, -4, -57, -19, -28, 58, 39, 35, 1, 34, -23, 40, -37, -10, 95, -5, 4, 53, -2, 77, 36, -94, 1, -39, -23, 51, -50, -45, -111, 37, -23, 49, -56, 72, 30, 65, 23, -48, -5, 13, -24, 44, 48, -17, -29, -33, 71, -9, 23, 47, -14, 39, -11, -4, -41, -3, -79, 26, 91, 7, -68, -32, -32, -64, 
  8, 41, 29, -17, -54, 10, -25, 16, 50, 44, -29, -37, -18, -51, -36, -51, -41, 1, 35, -51, -17, -21, -50, -14, 0, 8, -56, -43, 12, -51, -47, -21, -13, 51, 50, -20, -47, -39, 20, 0, -12, 35, 34, 42, -49, 38, -10, -16, -53, 36, -44, -23, -8, 28, -6, -57, -11, 45, -32, -22, 53, -11, 44, -10, 
  32, -52, 39, 9, -36, -47, 24, -40, -16, 23, 35, -40, -45, 25, -54, -6, -8, 5, 19, -26, -32, -1, -24, 56, -36, 5, -31, -55, -4, 7, 40, 40, -46, 32, 13, 38, -17, 11, 31, -38, -13, -41, -9, 22, 1, -4, 9, -23, 15, 10, 22, -34, 32, 48, 30, -32, -19, -6, -55, -35, -18, -22, 9, -55, 
  55, 18, -48, -32, 10, 28, 2, -18, -29, -4, 35, -11, -40, 0, -40, 9, 48, -37, -11, 68, -5, -61, -15, -49, 0, 17, 25, -16, -11, -44, -57, -17, -16, -17, 46, 13, -53, 57, 12, -27, -31, -50, 32, 49, -14, 21, 50, -65, -12, 20, 31, 35, 13, 63, -14, 0, -77, 11, -20, -34, -33, -47, -30, 15, 
  4, -1, -24, 42, -29, 35, 51, -20, -51, -39, 30, -53, -26, -21, 60, 1, -10, 55, 38, 24, 96, -97, 50, 7, 50, 67, -6, -42, -84, -7, -31, -23, 16, 127, 4, -3, 9, 47, -63, 23, 1, -80, 40, -26, 24, -16, -2, 22, 16, -30, 70, -43, -14, -8, -75, 43, -62, -45, 77, -13, 52, 15, 13, 62, 
  -49, 61, 29, 3, 14, -54, 41, 49, 2, 35, -9, 59, 17, -56, 24, 12, 59, 7, 74, -30, -87, -6, -33, 87, -12, -38, -44, 22, -22, 17, -35, -16, -30, -77, -56, -40, 24, 18, -49, -22, 40, 53, 8, 30, 49, 101, -62, 57, -7, -44, -68, 1, -49, -36, 30, -53, -20, 34, 34, -46, 8, -31, 25, 42, 
  -26, 19, 73, -56, 3, 49, 19, 58, -45, 40, 12, 25, -27, 10, 33, -14, 5, 6, -38, 16, 19, -9, 33, -18, -5, 1, -18, 22, -42, -49, 39, 36, 37, -81, -4, -4, -16, 34, -30, -41, -16, 39, 43, 18, 39, 53, -49, -56, -21, 32, 62, 0, 29, -49, 25, -26, -51, -28, -2, 46, -41, 5, -36, -18, 
  -8, 23, -25, -27, 42, 11, 53, 38, 3, -16, -24, 44, 22, 41, -50, -36, 2, -27, -3, -73, -56, 28, 18, -45, -6, -39, 9, 6, 28, 36, -62, -14, 25, 61, -37, -35, 7, 30, -47, -12, 55, -8, 13, 33, -20, 23, 23, -20, 16, 8, 21, -40, 26, -32, -23, -20, 48, 39, -42, 50, 9, -24, -51, 40, 
  25, -16, -41, 35, -31, 39, -30, 0, 25, -53, 49, 40, -29, -24, 20, 6, -36, 53, -26, 31, 73, -25, 5, -14, -49, -12, 33, 6, -43, 2, -19, -36, -45, 43, 45, 47, 43, -17, 4, -51, 26, 17, -2, -54, -19, 24, 23, 39, 56, -40, -5, 58, 42, -23, -54, -9, 2, -54, 15, 40, -29, -26, 29, -58, 
  39, -69, -5, 23, -33, 61, 33, 20, 1, -37, -8, -4, -49, 13, 25, -12, 24, 32, 16, -41, 95, -62, 3, -50, -13, 51, -7, -14, -15, -14, -37, -47, -20, 9, -34, -38, 60, 11, -37, -17, 17, -37, -47, -15, -30, -31, -24, 47, -25, 10, 21, -6, 8, 49, 56, 34, 36, -6, 59, -35, -12, -47, 50, -8, 
  4, -50, -67, -11, -60, 23, 34, -62, -19, -38, -5, 34, 29, 45, 20, 49, -26, 25, -2, -15, 89, 7, -21, 49, 25, -4, -20, 59, 16, -22, 50, 18, -51, 60, 37, -3, -22, -19, 32, 5, -40, -58, 39, -53, -43, 36, 45, -3, 35, 29, 5, -21, -3, 53, -17, 35, 24, 42, 16, -49, -49, 34, 39, -26, 
  24, 23, -105, -31, 1, -35, 48, -14, -27, 38, -4, 2, -74, 61, 33, 31, -53, 22, -33, 34, 55, -64, -33, -25, 43, 5, -9, -2, 30, 48, 33, -67, 41, 85, 58, 22, 3, 22, 3, -24, 44, -38, 27, -49, 20, -28, 21, -69, 50, 15, 60, 39, 36, 71, -28, 54, -54, 46, 25, 39, -48, -21, 26, 49, 
  27, -3, 4, -42, -2, -10, 43, 63, 39, 16, -18, -36, 17, -2, -61, 12, 4, -23, -33, -27, 4, 21, -13, 87, -52, -5, 24, -58, 45, 56, 12, -6, 22, -61, -35, 30, 42, 0, 18, -27, -56, 22, 12, 28, 54, 10, -59, -33, -52, 12, -45, -58, 26, 6, 15, 34, 39, 53, -51, 38, 37, -2, 40, -17, 
  -5, 39, -99, -25, -26, -3, -51, -37, -34, 35, 48, -2, -34, 57, -13, 44, -2, 4, -39, -41, 58, 6, 35, -50, 7, 54, -47, 42, -5, -2, -32, -65, -2, 35, 29, 63, 45, 34, -3, 20, -32, -14, 33, 22, -44, -89, -15, -15, -26, 58, 5, -52, -10, -8, -30, 37, 31, 32, 51, 0, -25, 24, 42, -52, 
  38, -29, 27, 21, -10, 1, 20, 1, 48, 52, -14, 12, -38, 29, 18, 18, 41, 0, 23, -35, -71, 2, -36, 84, -12, 45, 5, -34, 41, -9, -48, 36, 18, 5, -30, -12, 30, -25, 27, 1, 49, -13, -36, 46, 17, 24, -83, 13, 4, -48, -39, -48, 15, -37, 38, -10, -16, 36, 12, -1, -4, -6, 7, -17, 
  34, -32, 54, -54, -1, 46, -26, 40, -43, -50, 14, 4, 36, 49, 47, -36, -24, -12, -29, 3, -11, 44, 27, 10, 22, -29, 49, -2, 1, 20, 44, -12, 48, -38, -30, 40, -55, -1, 28, -2, 25, 45, 15, -57, -31, 63, 15, 10, 38, 0, 37, -57, -24, -37, 42, -49, -37, -11, -33, 38, 23, 42, 17, 47, 
  -10, 24, 99, 52, 14, 43, 47, 21, -51, 12, 36, -16, -13, 32, -36, 54, 65, 12, 45, -20, -38, 36, -3, 66, -56, 51, 49, -52, 44, 40, -22, 6, 15, -99, 24, 37, -52, 52, -69, -39, -46, 71, 49, -26, 0, 46, -72, 90, -50, 23, 28, -25, 53, -9, -6, -13, 1, 31, 23, -14, 73, -44, 57, 0, 
  14, 7, -30, 32, 1, -20, -37, 57, -46, 57, 50, 56, 24, -6, -11, -50, -20, -37, 52, -14, -87, 50, -9, -23, -21, 16, -4, 1, 21, 24, -16, 44, 46, -17, -9, -36, 3, -41, -7, -1, 9, -27, -13, -27, 11, 47, -32, 51, -2, -30, -22, 36, 47, 25, 16, -34, 48, -18, -22, -36, 5, 53, 29, -4, 
  -43, 32, 78, 50, -35, 23, 46, -24, 3, -1, 1, 34, 47, 1, -37, 48, -3, -24, -30, -43, 56, 22, 9, 72, -57, 46, 54, -5, 55, -21, 39, 3, -2, 28, 27, -5, -33, -19, -70, -31, 34, 68, -42, 13, -5, 90, 15, 13, -45, -66, 42, 18, -32, -28, -35, -16, 56, -1, 29, -7, 46, -5, -55, -47, 
  28, 28, -16, 40, -26, -41, 54, -94, 43, -24, -33, -21, 2, -28, 18, -29, -3, 30, 15, -42, 39, -17, 23, -74, 11, 4, 44, 59, 44, -23, 59, -8, 15, 45, 17, 52, 50, -41, -50, 48, -24, -70, 33, 6, -51, -27, -75, -17, -3, -35, 44, -29, 6, 24, 10, -48, 14, -50, 6, -29, -61, 5, 37, 52, 
  -2, -16, 0, 16, -59, 26, 31, -65, -48, 20, 12, 46, -20, 46, 74, -20, 44, 27, -30, 19, -19, 37, -8, -97, 61, 28, -48, 38, 0, 39, -5, -31, 17, -16, 30, 36, -21, -28, -19, -26, -1, -42, -49, 52, -23, -25, 2, -8, 64, 20, 4, 10, -4, -3, 21, -10, -37, -44, 42, 45, -61, 51, 53, 5, 
  -30, -15, -12, 49, -18, 53, 18, 35, -42, -51, -36, 20, -48, -28, -49, 30, -27, -11, 34, 43, 35, 38, -8, 0, -7, 49, -54, 10, 33, -41, -42, -41, -4, -7, -36, -24, -27, -42, 7, 40, -32, -9, -51, 46, 43, -13, -49, -36, 23, 0, -30, -45, 24, 14, 6, -2, -7, 14, -40, -7, -36, -51, 51, -46, 
  -62, 7, 82, -13, 73, -51, 24, -12, -2, 13, -12, 22, 57, 39, -28, -35, 43, 15, 80, -45, -9, 9, 27, 73, -2, -14, 55, 47, -18, -29, -17, 67, -63, -79, 4, -40, 22, -50, 11, -56, 54, -5, -34, -14, 47, 91, 10, 44, 28, 27, -48, -22, 9, -10, -32, -28, 38, 26, -27, 28, -11, -50, 25, 27, 
  14, -47, -47, 17, -35, 93, 19, -47, -1, -53, -18, -35, 55, 51, -13, 19, -65, -1, -22, 12, 68, -40, -48, 53, -17, 59, 11, 29, -26, -1, 9, -12, 30, 18, -42, -35, -27, 26, -10, 7, 0, -35, 27, -66, -22, -11, 25, 56, -3, 12, 53, 56, 38, -17, 67, -16, -43, 16, -12, 2, 35, 30, 54, 26, 
  -36, 43, -18, 1, 57, -28, -4, 65, 15, 50, -44, 23, 22, 21, 37, 11, -20, 16, 17, -49, -61, -23, 20, 28, -60, 46, 22, -53, 4, -4, -27, -9, 9, 10, -3, -26, 16, -52, -27, 18, -20, 6, -19, -5, 54, 84, 45, 63, 27, 8, -10, 10, -52, -54, 58, 21, -37, 14, 9, -36, 57, -5, 4, -12, 
  -22, 3, 105, -47, 22, -13, -45, 57, 21, -28, 32, 43, 67, 4, 35, 12, 3, -57, 39, 10, -36, 40, -35, 101, -49, 8, 5, 46, -21, 9, -18, -7, 22, -9, -42, -24, 1, 17, -7, -22, 15, 44, 61, -37, 17, 73, 29, 6, 37, -74, -24, 8, 47, 26, 6, -29, 37, 51, 22, -37, 23, -16, -6, 43, 
  37, 30, -94, -42, -35, 7, 1, -52, -52, 41, 21, -19, -52, 21, 22, 26, 23, -49, 42, 49, -29, -52, -3, -45, 42, -2, 23, 15, -12, -25, 11, -73, 29, 40, 45, 55, -10, 54, 34, 15, -38, -17, -55, 17, -6, -48, 56, 43, -6, 10, 53, 59, 21, 38, 6, -39, -59, -10, -19, 17, -27, -10, 68, 21, 
  9, 29, 53, -55, 35, 4, -3, -22, 45, -32, 26, -1, -1, -33, -29, 3, 54, -20, -21, 39, 22, 48, -56, -18, 16, 56, -35, 35, 56, -22, -45, 58, 10, -31, 16, -35, 24, 29, -40, 7, -37, 62, 8, 34, 20, 26, 11, 7, 47, -38, -61, -3, 34, 11, -23, 10, 48, -4, 49, 5, 61, 56, 42, 41, 
  11, 49, 7, -10, 31, -54, 39, 15, -38, -40, 21, 25, 39, -62, -28, -17, 30, -30, 56, 51, -73, -9, 48, 95, -16, 12, 7, 23, 52, -17, 7, 6, -10, -35, 33, 42, -57, 10, -15, 63, 19, 43, 22, 28, -12, 25, -70, 65, -6, -24, -74, -49, 33, -47, 27, 22, 33, -15, -19, -23, -1, 41, 8, -29, 
};
const TfArray<2, int> tensor_dimension3 = { 2, { 32,64 } };
const TfArray<1, float> quant3_scale = { 1, { 0.0043768924660980701, } };
const TfArray<1, int> quant3_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant3 = { (TfLiteFloatArray*)&quant3_scale, (TfLiteIntArray*)&quant3_zero, 0 };
const ALIGN(16) int32_t tensor_data4[32] = { 805, 1163, 2092, -1439, -91, -27, -1161, -780, 1757, 402, -468, -1300, -545, -979, -1514, 974, -1542, 1681, -75, 2162, 1001, 1166, -606, -1430, 0, 1588, -119, 1204, 1851, -1434, 913, 1687, };
const TfArray<1, int> tensor_dimension4 = { 1, { 32 } };
const TfArray<1, float> quant4_scale = { 1, { 0.00011566054308786988, } };
const TfArray<1, int> quant4_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant4 = { (TfLiteFloatArray*)&quant4_scale, (TfLiteIntArray*)&quant4_zero, 0 };
const ALIGN(16) int8_t tensor_data5[3*32] = { 
  -37, -83, -120, 74, 34, -2, 47, 100, -102, -12, -22, 81, 44, 97, 88, -40, -29, 0, -55, -127, -9, -10, 65, 71, 14, -60, 76, -41, -36, 92, -62, -54, 
  59, -10, 93, -75, 38, 0, -26, -2, 78, 14, -60, 18, 66, 18, -74, 28, -72, 83, 5, 92, 21, 74, -47, -96, -8, 105, -72, 14, 59, -103, -22, 33, 
  -80, 15, 12, 42, 47, 18, -23, -83, 13, -38, 8, -95, -88, -87, -8, -47, -76, 85, 69, -13, 82, -66, -49, 8, -75, -22, -102, 55, 28, 18, 81, 37, 
};
const TfArray<2, int> tensor_dimension5 = { 2, { 3,32 } };
const TfArray<1, float> quant5_scale = { 1, { 0.0053342804312705994, } };
const TfArray<1, int> quant5_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant5 = { (TfLiteFloatArray*)&quant5_scale, (TfLiteIntArray*)&quant5_zero, 0 };
const ALIGN(8) int32_t tensor_data6[3] = { -1398, 866, 623, };
const TfArray<1, int> tensor_dimension6 = { 1, { 3 } };
const TfArray<1, float> quant6_scale = { 1, { 0.00011750301928259432, } };
const TfArray<1, int> quant6_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant6 = { (TfLiteFloatArray*)&quant6_scale, (TfLiteIntArray*)&quant6_zero, 0 };
const TfArray<2, int> tensor_dimension7 = { 2, { 1,64 } };
const TfArray<1, float> quant7_scale = { 1, { 0.026425264775753021, } };
const TfArray<1, int> quant7_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant7 = { (TfLiteFloatArray*)&quant7_scale, (TfLiteIntArray*)&quant7_zero, 0 };
const TfArray<2, int> tensor_dimension8 = { 2, { 1,32 } };
const TfArray<1, float> quant8_scale = { 1, { 0.022027904167771339, } };
const TfArray<1, int> quant8_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant8 = { (TfLiteFloatArray*)&quant8_scale, (TfLiteIntArray*)&quant8_zero, 0 };
const TfArray<2, int> tensor_dimension9 = { 2, { 1,3 } };
const TfArray<1, float> quant9_scale = { 1, { 0.10955351591110229, } };
const TfArray<1, int> quant9_zero = { 1, { 9 } };
const TfLiteAffineQuantization quant9 = { (TfLiteFloatArray*)&quant9_scale, (TfLiteIntArray*)&quant9_zero, 0 };
const TfArray<2, int> tensor_dimension10 = { 2, { 1,3 } };
const TfArray<1, float> quant10_scale = { 1, { 0.00390625, } };
const TfArray<1, int> quant10_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant10 = { (TfLiteFloatArray*)&quant10_scale, (TfLiteIntArray*)&quant10_zero, 0 };
const TfLiteFullyConnectedParams opdata0 = { kTfLiteActRelu, kTfLiteFullyConnectedWeightsFormatDefault, false, false };
const TfArray<3, int> inputs0 = { 3, { 0,1,2 } };
const TfArray<1, int> outputs0 = { 1, { 7 } };
const TfLiteFullyConnectedParams opdata1 = { kTfLiteActRelu, kTfLiteFullyConnectedWeightsFormatDefault, false, false };
const TfArray<3, int> inputs1 = { 3, { 7,3,4 } };
const TfArray<1, int> outputs1 = { 1, { 8 } };
const TfLiteFullyConnectedParams opdata2 = { kTfLiteActNone, kTfLiteFullyConnectedWeightsFormatDefault, false, false };
const TfArray<3, int> inputs2 = { 3, { 8,5,6 } };
const TfArray<1, int> outputs2 = { 1, { 9 } };
const TfLiteSoftmaxParams opdata3 = { 1 };
const TfArray<1, int> inputs3 = { 1, { 9 } };
const TfArray<1, int> outputs3 = { 1, { 10 } };
const TensorInfo_t tensorData[] = {
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 64, (TfLiteIntArray*)&tensor_dimension0, 12, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant0))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data1, (TfLiteIntArray*)&tensor_dimension1, 768, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant1))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data2, (TfLiteIntArray*)&tensor_dimension2, 256, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant2))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data3, (TfLiteIntArray*)&tensor_dimension3, 2048, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant3))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data4, (TfLiteIntArray*)&tensor_dimension4, 128, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant4))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data5, (TfLiteIntArray*)&tensor_dimension5, 96, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant5))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data6, (TfLiteIntArray*)&tensor_dimension6, 12, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant6))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension7, 64, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant7))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 64, (TfLiteIntArray*)&tensor_dimension8, 32, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant8))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 16, (TfLiteIntArray*)&tensor_dimension9, 3, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant9))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension10, 3, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant10))}, },
};const NodeInfo_t nodeData[] = {
  { (TfLiteIntArray*)&inputs0, (TfLiteIntArray*)&outputs0, const_cast<void*>(static_cast<const void*>(&opdata0)), OP_FULLY_CONNECTED, },
  { (TfLiteIntArray*)&inputs1, (TfLiteIntArray*)&outputs1, const_cast<void*>(static_cast<const void*>(&opdata1)), OP_FULLY_CONNECTED, },
  { (TfLiteIntArray*)&inputs2, (TfLiteIntArray*)&outputs2, const_cast<void*>(static_cast<const void*>(&opdata2)), OP_FULLY_CONNECTED, },
  { (TfLiteIntArray*)&inputs3, (TfLiteIntArray*)&outputs3, const_cast<void*>(static_cast<const void*>(&opdata3)), OP_SOFTMAX, },
};
static std::vector<void*> overflow_buffers;
static void * AllocatePersistentBuffer(struct TfLiteContext* ctx,
                                       size_t bytes) {
  void *ptr;
  if (current_location - bytes < tensor_boundary) {
    // OK, this will look super weird, but.... we have CMSIS-NN buffers which
    // we cannot calculate beforehand easily.
    ptr = ei_calloc(bytes, 1);
    if (ptr == NULL) {
      printf("ERR: Failed to allocate persistent buffer of size %d\n", (int)bytes);
      return NULL;
    }
    overflow_buffers.push_back(ptr);
    return ptr;
  }

  current_location -= bytes;

  ptr = current_location;
  memset(ptr, 0, bytes);

  return ptr;
}
typedef struct {
  size_t bytes;
  void *ptr;
} scratch_buffer_t;
static std::vector<scratch_buffer_t> scratch_buffers;

static TfLiteStatus RequestScratchBufferInArena(struct TfLiteContext* ctx, size_t bytes,
                                                int* buffer_idx) {
  scratch_buffer_t b;
  b.bytes = bytes;

  b.ptr = AllocatePersistentBuffer(ctx, b.bytes);
  if (!b.ptr) {
    return kTfLiteError;
  }

  scratch_buffers.push_back(b);

  *buffer_idx = scratch_buffers.size() - 1;

  return kTfLiteOk;
}

static void* GetScratchBuffer(struct TfLiteContext* ctx, int buffer_idx) {
  if (buffer_idx > static_cast<int>(scratch_buffers.size()) - 1) {
    return NULL;
  }
  return scratch_buffers[buffer_idx].ptr;
}

static TfLiteTensor* GetTensor(const struct TfLiteContext* context,
                               int tensor_idx) {
  return &tflTensors[tensor_idx];
}

static TfLiteEvalTensor* GetEvalTensor(const struct TfLiteContext* context,
                                       int tensor_idx) {
  return &tflEvalTensors[tensor_idx];
}

} // namespace

TfLiteStatus trained_model_init( void*(*alloc_fnc)(size_t,size_t) ) {
#ifdef EI_CLASSIFIER_ALLOCATION_HEAP
  tensor_arena = (uint8_t*) alloc_fnc(16, kTensorArenaSize);
  if (!tensor_arena) {
    printf("ERR: failed to allocate tensor arena\n");
    return kTfLiteError;
  }
#else
  memset(tensor_arena, 0, kTensorArenaSize);
#endif
  tensor_boundary = tensor_arena;
  current_location = tensor_arena + kTensorArenaSize;
  ctx.AllocatePersistentBuffer = &AllocatePersistentBuffer;
  ctx.RequestScratchBufferInArena = &RequestScratchBufferInArena;
  ctx.GetScratchBuffer = &GetScratchBuffer;
  ctx.GetTensor = &GetTensor;
  ctx.GetEvalTensor = &GetEvalTensor;
  ctx.tensors = tflTensors;
  ctx.tensors_size = 11;
  for(size_t i = 0; i < 11; ++i) {
    tflTensors[i].type = tensorData[i].type;
    tflEvalTensors[i].type = tensorData[i].type;
    tflTensors[i].is_variable = 0;

#if defined(EI_CLASSIFIER_ALLOCATION_HEAP)
    tflTensors[i].allocation_type = tensorData[i].allocation_type;
#else
    tflTensors[i].allocation_type = (tensor_arena <= tensorData[i].data && tensorData[i].data < tensor_arena + kTensorArenaSize) ? kTfLiteArenaRw : kTfLiteMmapRo;
#endif
    tflTensors[i].bytes = tensorData[i].bytes;
    tflTensors[i].dims = tensorData[i].dims;
    tflEvalTensors[i].dims = tensorData[i].dims;

#if defined(EI_CLASSIFIER_ALLOCATION_HEAP)
    if(tflTensors[i].allocation_type == kTfLiteArenaRw){
      uint8_t* start = (uint8_t*) ((uintptr_t)tensorData[i].data + (uintptr_t) tensor_arena);

     tflTensors[i].data.data =  start;
     tflEvalTensors[i].data.data =  start;
    }
    else{
       tflTensors[i].data.data = tensorData[i].data;
       tflEvalTensors[i].data.data = tensorData[i].data;
    }
#else
    tflTensors[i].data.data = tensorData[i].data;
    tflEvalTensors[i].data.data = tensorData[i].data;
#endif // EI_CLASSIFIER_ALLOCATION_HEAP
    tflTensors[i].quantization = tensorData[i].quantization;
    if (tflTensors[i].quantization.type == kTfLiteAffineQuantization) {
      TfLiteAffineQuantization const* quant = ((TfLiteAffineQuantization const*)(tensorData[i].quantization.params));
      tflTensors[i].params.scale = quant->scale->data[0];
      tflTensors[i].params.zero_point = quant->zero_point->data[0];
    }
    if (tflTensors[i].allocation_type == kTfLiteArenaRw) {
      auto data_end_ptr = (uint8_t*)tflTensors[i].data.data + tensorData[i].bytes;
      if (data_end_ptr > tensor_boundary) {
        tensor_boundary = data_end_ptr;
      }
    }
  }
  if (tensor_boundary > current_location /* end of arena size */) {
    printf("ERR: tensor arena is too small, does not fit model - even without scratch buffers\n");
    return kTfLiteError;
  }
  registrations[OP_FULLY_CONNECTED] = Register_FULLY_CONNECTED();
  registrations[OP_SOFTMAX] = Register_SOFTMAX();

  for(size_t i = 0; i < 4; ++i) {
    tflNodes[i].inputs = nodeData[i].inputs;
    tflNodes[i].outputs = nodeData[i].outputs;
    tflNodes[i].builtin_data = nodeData[i].builtin_data;
tflNodes[i].custom_initial_data = nullptr;
      tflNodes[i].custom_initial_data_size = 0;
if (registrations[nodeData[i].used_op_index].init) {
      tflNodes[i].user_data = registrations[nodeData[i].used_op_index].init(&ctx, (const char*)tflNodes[i].builtin_data, 0);
    }
  }
  for(size_t i = 0; i < 4; ++i) {
    if (registrations[nodeData[i].used_op_index].prepare) {
      TfLiteStatus status = registrations[nodeData[i].used_op_index].prepare(&ctx, &tflNodes[i]);
      if (status != kTfLiteOk) {
        return status;
      }
    }
  }
  return kTfLiteOk;
}

static const int inTensorIndices[] = {
  0, 
};
TfLiteTensor* trained_model_input(int index) {
  return &ctx.tensors[inTensorIndices[index]];
}

static const int outTensorIndices[] = {
  10, 
};
TfLiteTensor* trained_model_output(int index) {
  return &ctx.tensors[outTensorIndices[index]];
}

TfLiteStatus trained_model_invoke() {
  for(size_t i = 0; i < 4; ++i) {
    TfLiteStatus status = registrations[nodeData[i].used_op_index].invoke(&ctx, &tflNodes[i]);

#if EI_CLASSIFIER_PRINT_STATE
    ei_printf("layer %lu\n", i);
    ei_printf("    inputs:\n");
    for (size_t ix = 0; ix < tflNodes[i].inputs->size; ix++) {
      auto d = tensorData[tflNodes[i].inputs->data[ix]];

      size_t data_ptr = (size_t)d.data;

      if (d.allocation_type == kTfLiteArenaRw) {
        data_ptr = (size_t)tensor_arena + data_ptr;
      }

      if (d.type == TfLiteType::kTfLiteInt8) {
        int8_t* data = (int8_t*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes; jx++) {
          ei_printf("%d ", data[jx]);
        }
      }
      else {
        float* data = (float*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes / 4; jx++) {
          ei_printf("%f ", data[jx]);
        }
      }
      ei_printf("\n");
    }
    ei_printf("\n");

    ei_printf("    outputs:\n");
    for (size_t ix = 0; ix < tflNodes[i].outputs->size; ix++) {
      auto d = tensorData[tflNodes[i].outputs->data[ix]];

      size_t data_ptr = (size_t)d.data;

      if (d.allocation_type == kTfLiteArenaRw) {
        data_ptr = (size_t)tensor_arena + data_ptr;
      }

      if (d.type == TfLiteType::kTfLiteInt8) {
        int8_t* data = (int8_t*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes; jx++) {
          ei_printf("%d ", data[jx]);
        }
      }
      else {
        float* data = (float*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes / 4; jx++) {
          ei_printf("%f ", data[jx]);
        }
      }
      ei_printf("\n");
    }
    ei_printf("\n");
#endif // EI_CLASSIFIER_PRINT_STATE

    if (status != kTfLiteOk) {
      return status;
    }
  }
  return kTfLiteOk;
}

TfLiteStatus trained_model_reset( void (*free_fnc)(void* ptr) ) {
#ifdef EI_CLASSIFIER_ALLOCATION_HEAP
  free_fnc(tensor_arena);
#endif
  scratch_buffers.clear();
  for (size_t ix = 0; ix < overflow_buffers.size(); ix++) {
    free(overflow_buffers[ix]);
  }
  overflow_buffers.clear();
  return kTfLiteOk;
}
